import at.jku.ssw.Map;
import at.jku.ssw.PrimeNumbers;

import at.jku.students.HashMapLinear;

class HashMapLinearTest {
  public static void main(String[] args) {
    Map m = new HashMapLinear(5);
    
    Out.println("m.put(\"Wolfinger\", \"2468-4359\")");
    m.put("Wolfinger", "2468-4359");
    Out.println("m.put(\"Lehner\", \"0664 / 123456\")");
    m.put("Lehner", "0664 / 123456");
    Out.println("m.put(\"Neuer\", null)");
    m.put("Neuer", null);
    
    makeDot("1.dot", m);
    
    Out.println("m.containsKey(\"Wolfinger\")=" + m.containsKey("Wolfinger"));
    Out.println("m.containsKey(\"Mueller\")=" + m.containsKey("Mueller"));

    Out.println("m.get(\"Wolfinger\")=" + m.get("Wolfinger"));
    Out.println("m.get(\"Mueller\")=" + m.get("Mueller"));
    Out.println("m.containsKey(\"Mueller\")=" + m.containsKey("Mueller"));
    Out.println("m.get(\"Neuer\")=" + m.get("Neuer"));
    Out.println("m.containsKey(\"Neuer\")=" + m.containsKey("Neuer"));

    Out.println("m.containsKey(\"Lehner\")=" + m.containsKey("Lehner"));
    Out.println("m.remove(\"Lehner\")=" + m.remove("Lehner"));
    Out.println("m.containsKey(\"Lehner\")=" + m.containsKey("Lehner"));

    makeDot("2.dot", m);

    ((HashMapLinear) m).rehash(PrimeNumbers.nextPrime(5 * 2));
    makeDot("3.dot", m);
  }
  
  static void makeDot(String fileName, Map map) {
    Out.open(fileName);
    Out.println(((HashMapLinear) map).makeDot());
    Out.close();
  }
}